let words1 = [[0]; [0; 0; 0]; [0; 1]; [1; 1]]
let words2 = [[]; [0; 0]; [1; 0; 1]]

(* tree1 represents the set of words words1 *)
let tree1 =
  Node (false,
        Node (true, Node (false, Node (true, Empty, Empty), Empty),
              Node (true, Empty, Empty)),
        Node (false, Empty, Node (true, Empty, Empty)))
  
(* tree2 represents the set of words words2 *)
let tree2 =
  Node (true,
        Node (false, Node (true, Empty, Empty), Empty),
        Node (false, Node (false, Empty, Node (true, Empty, Empty)), Empty))

  
let tree1_bis = set_is_end tree1

let _ = tree_mem  [] tree1			     
let _ = tree_mem  [] tree2			     
let _ = tree_mem  [0; 0; 0] tree1
let _ = tree_mem  [0; 0; 0] tree2
let _ = tree_mem [0; 0] tree1
let _ = tree_mem [0; 0] tree2
let _ = tree_mem [1; 0] tree1
let _ = tree_mem [1; 0] tree2

let _ = distribute 0 words1
let _ = distribute 1 words1
		    
let t11  = tree_insert [0] Empty
let t12 = tree_insert [0; 0; 0] t11
let t13 = tree_insert [0; 1] t12
let t14 = tree_insert [1; 1] t13
let _ = tree1 = t14
      
let t21  = tree_insert [] Empty
let t22 = tree_insert [0; 0] t21
let t23 = tree_insert [1; 0; 1] t22
let _ = tree2 = t23
      
let t1 = tree_of_words words1
let _ = t1 = tree1
let t2 = tree_of_words words2
let _ = t2 = tree2

let _ = words_of t1
let _ = words_of t2
