let empty_word = []
let fifteen = [1; 1; 1; 1]
let w001 = [0; 0; 1]
let w0010 = [0; 0; 1; 0]
let w00100 = [0; 0; 1; 0; 0]
let w001001 = [0; 0; 1; 0; 0; 1]
let words = [w001; w0010; w00100; w001001]
	      
let wtree = tree_of_words words

let _ = assert(not (tree_mem empty_word wtree))
let _ = assert(tree_mem empty_word (set_is_end wtree))
let _ = assert(not (tree_mem empty_word (tree_remove empty_word (set_is_end wtree))))
let _ = assert(tree_mem fifteen (tree_insert fifteen wtree))
let wt1 = tree_insert [0; 1] Empty
let _ = assert(wt1 = Node (false, Node (false, Empty, Node (true, Empty, Empty)), Empty))
let wt2 = tree_insert [0; 0; 1] wt1
let _ = assert(wt2 = tree_insert [0; 1] wt2)
let wt3 = tree_insert [] wt2
let words3 = words_of wt3
let _ = assert(List.mem [0; 1] words3)
let _ = assert(not (List.mem [0; 0] words3))
let _ = assert(List.mem [] words3)

let _ = assert(tree_remove [0; 0; 1] wt2 = wt1)
let _ = assert(tree_remove [0; 1] wt1 = Empty)
